%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  IALS
%global packver   0.1.3
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          0.1.3
Release:          1%{?dist}%{?buildtag}
Summary:          Iterative Alternating Least Square Estimation for Large-Dimensional Matrix Factor Model

License:          GPL-2 | GPL-3
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel >= 4.0
Requires:         R-core >= 4.0
BuildArch:        noarch
BuildRequires:    R-CRAN-RSpectra 
BuildRequires:    R-CRAN-pracma 
BuildRequires:    R-CRAN-HDMFA 
Requires:         R-CRAN-RSpectra 
Requires:         R-CRAN-pracma 
Requires:         R-CRAN-HDMFA 

%description
The matrix factor model has drawn growing attention for its advantage in
achieving two-directional dimension reduction simultaneously for
matrix-structured observations. In contrast to the Principal Component
Analysis (PCA)-based methods, we propose a simple Iterative Alternating
Least Squares (IALS) algorithm for matrix factor model, see the details in
He et al. (2023) <arXiv:2301.00360>.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
